/*20:*/
#line 316 "./test-it.w"

/*25:*/
#line 390 "./test-it.w"

#include <QtCore/QCoreApplication> 
#include "qt-part.h"

static char*_m_argv[2]= {"it's me",NULL};
static int _m_argc= 1;
class TestApp:public QCoreApplication{Q_OBJECT
public:
TestApp():QCoreApplication(_m_argc,_m_argv){}
~TestApp(){}
};


void*create_test_app(){return new TestApp();}
void*get_test_app(){return QCoreApplication::instance();}
void call_test_app_quit(){TApp->quit();}
void exec_test_app(){TApp->exec();}

/*:25*/
#line 317 "./test-it.w"

/*23:*/
#line 334 "./test-it.w"

#include <QtCore/QSocketNotifier> 

class ProgramIOSelect:public QSocketNotifier
{Q_OBJECT
public:
ProgramIOSelect(QObject*parent,
void*dat,call_io_function ciof,int fd,
unsigned type):
QSocketNotifier(fd,(QSocketNotifier::Type)type,parent),
m_data(dat),
m_io_function(ciof)
{
connect(this,SIGNAL(activated(int)),
this,SLOT(call_io(int)));
setEnabled(true);
}

public slots:
void call_io(int fd){m_io_function(this,m_data,fd);}

private:
void*m_data;
call_io_function m_io_function;
};


void*create_io_channel(int fd,int type,void*dat,call_io_function f)
{
ProgramIOSelect*new_io= new ProgramIOSelect(NULL,dat,f,fd,type);
return new_io;
}

void destroy_io_channel(void**X)
{
ProgramIOSelect*del_io= (ProgramIOSelect*)(*X);
del_io->setEnabled(false);
delete del_io;
*X= NULL;
}

void enable_io_channel(void*ios_ptr,int enable)
{
ProgramIOSelect*io= (ProgramIOSelect*)(ios_ptr);
io->setEnabled(enable);
}


/*:23*/
#line 318 "./test-it.w"

#include "moc_qt-part.cc"

/*:20*/
